/**
 * ISC License
 *
 * Copyright (c) 2018, Aleck Greenham
 *
 * Permission to use, copy, modify, and/or distribute this software for any purpose with or without fee is hereby granted, provided that the above copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}Object.defineProperty(exports,"__esModule",{value:!0});var ReactDOM=_interopDefault(require("react-dom")),FocusDirection={LEFT:"LEFT",RIGHT:"RIGHT",UP:"UP",DOWN:"DOWN"},NotProvided="NOT_PROVIDED",_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},classCallCheck=function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")},createClass=function(){function e(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,o.key,o)}}return function(t,r,o){return r&&e(t.prototype,r),o&&e(t,o),t}}(),_extends=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var o in r)Object.prototype.hasOwnProperty.call(r,o)&&(e[o]=r[o])}return e},slicedToArray=function(){return function(e,t){if(Array.isArray(e))return e;if(Symbol.iterator in Object(e))return function(e,t){var r=[],o=!0,n=!1,i=void 0;try{for(var c,u=e[Symbol.iterator]();!(o=(c=u.next()).done)&&(r.push(c.value),!t||r.length!==t);o=!0);}catch(e){n=!0,i=e}finally{try{!o&&u.return&&u.return()}finally{if(n)throw i}}return r}(e,t);throw new TypeError("Invalid attempt to destructure non-iterable instance")}}(),toConsumableArray=function(e){if(Array.isArray(e)){for(var t=0,r=Array(e.length);t<e.length;t++)r[t]=e[t];return r}return Array.from(e)},RefManager=function(){function e(){classCallCheck(this,e),this._refs={},this._focused={},this._focusListeners=[]}return createClass(e,null,[{key:"refIsFocused",value:function(e){return e&&e===document.activeElement&&!!e.parentNode}},{key:"focus",value:function(e){if(e){if(e.focus)return e.focus(),e;var t=ReactDOM.findDOMNode(e);return t&&t.parentNode?(t.focus(),t):null}return null}},{key:"scrollTo",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:NotProvided;if(e){if(e.scrollIntoView)return e.scrollIntoView(),e;var r=ReactDOM.findDOMNode(e);return r&&r.parentNode?(r.scrollIntoView(t!==NotProvided&&t),r):null}return null}}]),createClass(e,[{key:"set",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:NotProvided,r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:NotProvided;r===NotProvided?this._refs[e]={ref:t,key:e}:(this._refs[e]||(this._refs[e]={}),this._refs[e][t]={ref:r,key:t})}},{key:"get",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:NotProvided,t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:NotProvided,r=this._get(e,t);return r&&r.ref||r}},{key:"_get",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:NotProvided,t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:NotProvided,r=this._refs[e];return t===NotProvided?r:r&&r[t]}},{key:"setCurrentFocus",value:function(e){var t=this._focused;return this._focused=e,this._focusListeners.forEach(function(r){r(t,e)}),this._focused}},{key:"getCurrentFocus",value:function(){return this._focused||{}}},{key:"isFocusedRefInDOM",value:function(){return this.constructor.refIsFocused(this.getCurrentFocus().DOMRef)}},{key:"focus",value:function(e,t){var r=t.id,o=t.collectionId,n=t.context;if(e){var i=this.constructor.focus(e);return this.setCurrentFocus({ref:e,DOMRef:i,id:r,collectionId:o,context:n,applied:!!i})}return{ref:null,DOMRef:null,id:r,collectionId:o,context:n,applied:!1}}},{key:"focusById",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:NotProvided,r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:NotProvided;if(r===NotProvided){var o=t===NotProvided?[void 0,{}]:"object"===(void 0===t?"undefined":_typeof(t))?[void 0,t||{}]:[t,{}],n=slicedToArray(o,2),i=n[0],c=n[1];if(i){var u=this._get(e,i);return this.focus(u&&u.ref,_extends({id:u&&u.key,collectionId:e},c))}return this.focus(this.get(e),_extends({collectionId:e},c))}var l=this.get(e,t);return this.focus(l&&l.ref,_extends({},r,{id:l&&l.key,collectionId:e}))}},{key:"focusNextById",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},r=this.get(e);return this.focusNext(r,_extends({},t,{collectionId:e}))}},{key:"focusNext",value:function(e,t){var r=t.direction,o=void 0===r?FocusDirection.RIGHT:r,n=t.indexes,i=t.collectionId,c=t.context,u=t.collectionWidth,l=void 0===u?1:u,s=t.yWrap,d=void 0!==s&&s,f=t.xWrap,a=void 0!==f&&f;if(!e)return{ref:null,DOMRef:null,collectionId:i,context:c,applied:!1};var v=this.getCurrentFocus(),h=n||Object.keys(e),y=h.map(function(e){return e.toString()}).indexOf(void 0!==v.id&&v.id.toString());if(v.collectionId!==i||-1===y){var p=h[0],g=this._get(i,p);return this.focus(g&&g.ref,{id:g&&g.key,collectionId:i,context:c})}var N=e[function(){if(o===FocusDirection.LEFT){var e=y-1;return e>=0?h[e]:a?h[h.length-1]:h[0]}if(o===FocusDirection.RIGHT){var t=y+1;return t<h.length?h[t]:a?h[0]:h[h.length-1]}if(o===FocusDirection.UP){var r=y-l;return r>=0?h[r]:d?h[h.length-1]:h[0]}if(o===FocusDirection.DOWN){var n=y+l;return n<h.length?h[n]:d?h[0]:h[h.length-l]}}()];return this.focus(N&&N.ref,{id:N&&N.key,collectionId:i,context:c})}},{key:"scrollToById",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:NotProvided,r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:NotProvided,o=slicedToArray(r===NotProvided?t===NotProvided?[NotProvided,NotProvided]:"string"==typeof t?[t,NotProvided]:[NotProvided,t]:[t,r],2),n=o[0],i=o[1],c=this._get(e,n);if(c){var u=this.constructor.scrollTo(c.ref,i);return{id:c.key,collectionId:e,ref:c.ref,DOMRef:u,applied:!!u}}return{id:n,collectionId:e,ref:null,DOMRef:null,applied:!1}}},{key:"scrollToFocused",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:NotProvided,t=this.getCurrentFocus();if(t){var r=this.constructor.scrollTo(t.DOMRef,e);return{id:t.id,collectionId:t.collectionId,ref:t.ref,DOMRef:r,applied:!!r}}return{id:t.id,collectionId:t.collectionId,ref:null,DOMRef:null,applied:!1}}},{key:"addFocusChangeListener",value:function(e){return this._focusListeners.push(e),e}},{key:"removeFocusChangeListener",value:function(e){var t=this._focusListeners.indexOf(e);-1!==t&&(this._focusListeners=[].concat(toConsumableArray(this._focusListeners.splice(0,t)),toConsumableArray(this._focusListeners.splice(t+1))))}}]),e}();exports.FocusDirection=FocusDirection,exports.default=RefManager;
